import _mergeJSXProps from 'babel-helper-vue-jsx-merge-props';
import _extends from 'babel-runtime/helpers/extends';
import './style/index.less';

var svgBaseProps = {
    width: '1em',
    height: '1em',
    fill: 'currentColor',
    'aria-hidden': 'true',
    focusable: 'false'
};

var requireAll = function requireAll(context) {
    return context.keys().map(context);
};
var req = require.context('./svg', false, /\.svg$/);
requireAll(req);

var Icon = {
    functional: true,
    name: 'SnIcon',
    props: {
        type: {
            type: String,
            required: true
        },
        viewBox: String,
        spin: {
            type: Boolean,
            'default': false
        }
    },
    render: function render(h, context) {
        var props = context.props,
            slots = context.slots,
            listeners = context.listeners,
            data = context.data;
        var type = props.type,
            spin = props.spin;

        var children = slots()['default'] || [];
        children = children.length === 0 ? undefined : children;

        var classString = {
            'sn-icon': true
        };
        classString['sn-icon-' + type] = !!type;
        if (data['class']) {
            data['class'].trim().split(' ').map(function (item) {
                classString[item] = true;
            });
        }
        if (data.staticClass) {
            data.staticClass.trim().split(' ').map(function (item) {
                classString[item] = true;
            });
        }
        var svgClassString = {};
        svgClassString['sn-icon-spin'] = !!spin || type === 'loading';

        var innerSvgProps = {
            attrs: _extends({}, svgBaseProps),
            'class': svgClassString
        };
        var useProps = {
            attrs: {
                'xlink:href': '#' + type
            }
        };
        var innerNode = h(
            'svg',
            _mergeJSXProps([innerSvgProps, { 'class': svgClassString }]),
            [h('use', useProps)]
        );
        // functional component not support nativeOn，https://github.com/vuejs/vue/issues/7526
        var iProps = _extends({}, data, {
            on: _extends({}, listeners, data.nativeOn),
            'class': classString,
            staticClass: ''
        });
        return h(
            'i',
            iProps,
            [innerNode]
        );
    }
};

Icon.install = function (Vue) {
    Vue.component(Icon.name, Icon);
};

export default Icon;